﻿Imports ThinkGeo.MapSuite.DesktopEdition
Imports ThinkGeo.MapSuite.Core
Public Class Form1
   Private moShapefile As ShapeFileFeatureLayer
   Private moMap As WinformsMap = WinformsMap1
   Private moInMemoryLayer As New InMemoryFeatureLayer
   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      Dim sPath As String = "..\..\Data\ImALine.shp"

      moMap = WinformsMap1

      moShapefile = New ShapeFileFeatureLayer(sPath, ShapeFileReadWriteMode.ReadWrite)
      moShapefile.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Blue, 1, False)
      moShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      Dim oOverlay As New LayerOverlay

      moInMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Red, 2, False)
      moInMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20


      oOverlay.Layers.Add(moShapefile)
      oOverlay.Layers.Add(moInMemoryLayer)
      moMap.Overlays.Add(oOverlay)
      moMap.MapUnit = GeographyUnit.Meter
      moShapefile.Open()
      moMap.CurrentExtent = moShapefile.GetBoundingBox
      moMap.Refresh()

   End Sub

   Private Sub WinformsMap1_MapClick(sender As Object, e As ThinkGeo.MapSuite.DesktopEdition.MapClickWinformsMapEventArgs) Handles WinformsMap1.MapClick
      '***** Find the line the user clicked on, use GetLineOnALine to recreate the line, then
      '***** draw the newly created line on top of the original line
      Dim oFeatures = moShapefile.QueryTools.GetFeaturesWithinDistanceOf(e.WorldLocation, moMap.MapUnit, DistanceUnit.Meter, 6000, ReturningColumnsType.AllColumns)
      If oFeatures.Count > 0 Then
         moInMemoryLayer.InternalFeatures.Clear()

         Dim oLine As LineShape = CType(oFeatures(0).GetShape, MultilineShape).Lines(0)
         Dim oLine2 = oLine.GetLineOnALine(New PointShape(oLine.Vertices(0)), New PointShape(oLine.Vertices(oLine.Vertices.Count - 1)))

         moInMemoryLayer.InternalFeatures.Add(New Feature(oLine2))
         moMap.Refresh()
      End If
   End Sub
End Class
